Give commit message reencoding for output on MinGW a chance
[git/dscho.git] / t / test-lib.sh
blob6f08071f902ea303f752c9c55a5e3a406b5dd359
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # for git on windows so stdin will not be misdetected as attached to a
19 # terminal
20 exec < /dev/null
22 # if --tee was passed, write the output not only to the terminal, but
23 # additionally to the file test-results/$BASENAME.out, too.
24 case "$GIT_TEST_TEE_STARTED, $* " in
25 done,*)
26 # do not redirect again
28 *' --tee '*|*' --va'*)
29 mkdir -p test-results
30 BASE=test-results/$(basename "$0" .sh)
31 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
32 echo $? > $BASE.exit) | tee $BASE.out
33 test "$(cat $BASE.exit)" = 0
34 exit
36 esac
38 # Keep the original TERM for say_color
39 ORIGINAL_TERM=$TERM
41 # For repeatability, reset the environment to known value.
42 LANG=C
43 LC_ALL=C
44 PAGER=cat
45 TZ=UTC
46 TERM=dumb
47 export LANG LC_ALL PAGER TERM TZ
48 EDITOR=:
49 unset VISUAL
50 unset GIT_EDITOR
51 unset AUTHOR_DATE
52 unset AUTHOR_EMAIL
53 unset AUTHOR_NAME
54 unset COMMIT_AUTHOR_EMAIL
55 unset COMMIT_AUTHOR_NAME
56 unset EMAIL
57 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
58 unset GIT_AUTHOR_DATE
59 GIT_AUTHOR_EMAIL=author@example.com
60 GIT_AUTHOR_NAME='A U Thor'
61 unset GIT_COMMITTER_DATE
62 GIT_COMMITTER_EMAIL=committer@example.com
63 GIT_COMMITTER_NAME='C O Mitter'
64 unset GIT_DIFF_OPTS
65 unset GIT_DIR
66 unset GIT_WORK_TREE
67 unset GIT_EXTERNAL_DIFF
68 unset GIT_INDEX_FILE
69 unset GIT_OBJECT_DIRECTORY
70 unset GIT_CEILING_DIRECTORIES
71 unset SHA1_FILE_DIRECTORIES
72 unset SHA1_FILE_DIRECTORY
73 unset GIT_NOTES_REF
74 unset GIT_NOTES_DISPLAY_REF
75 unset GIT_NOTES_REWRITE_REF
76 unset GIT_NOTES_REWRITE_MODE
77 unset GIT_REFLOG_ACTION
78 unset GIT_CHERRY_PICK_HELP
79 unset GIT_QUIET
80 GIT_MERGE_VERBOSITY=5
81 export GIT_MERGE_VERBOSITY
82 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
83 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
84 export EDITOR
86 # Protect ourselves from common misconfiguration to export
87 # CDPATH into the environment
88 unset CDPATH
90 unset GREP_OPTIONS
92 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
93 1|2|true)
94 echo "* warning: Some tests will not work if GIT_TRACE" \
95 "is set as to trace on STDERR ! *"
96 echo "* warning: Please set GIT_TRACE to something" \
97 "other than 1, 2 or true ! *"
99 esac
101 # Convenience
103 # A regexp to match 5 and 40 hexdigits
104 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
105 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
107 # Each test should start with something like this, after copyright notices:
109 # test_description='Description of this test...
110 # This test checks if command xyzzy does the right thing...
112 # . ./test-lib.sh
113 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
114 TERM=$ORIGINAL_TERM &&
115 export TERM &&
116 [ -t 1 ] &&
117 tput bold >/dev/null 2>&1 &&
118 tput setaf 1 >/dev/null 2>&1 &&
119 tput sgr0 >/dev/null 2>&1
120 ) &&
121 color=t
123 while test "$#" -ne 0
125 case "$1" in
126 -d|--d|--de|--deb|--debu|--debug)
127 debug=t; shift ;;
128 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
129 immediate=t; shift ;;
130 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
131 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
132 -h|--h|--he|--hel|--help)
133 help=t; shift ;;
134 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
135 verbose=t; shift ;;
136 -q|--q|--qu|--qui|--quie|--quiet)
137 # Ignore --quiet under a TAP::Harness. Saying how many tests
138 # passed without the ok/not ok details is always an error.
139 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
140 --with-dashes)
141 with_dashes=t; shift ;;
142 --no-color)
143 color=; shift ;;
144 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
145 valgrind=t; verbose=t; shift ;;
146 --tee)
147 shift ;; # was handled already
148 --root=*)
149 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
150 shift ;;
152 echo "error: unknown test option '$1'" >&2; exit 1 ;;
153 esac
154 done
156 if test -n "$color"; then
157 say_color () {
159 TERM=$ORIGINAL_TERM
160 export TERM
161 case "$1" in
162 error) tput bold; tput setaf 1;; # bold red
163 skip) tput bold; tput setaf 2;; # bold green
164 pass) tput setaf 2;; # green
165 info) tput setaf 3;; # brown
166 *) test -n "$quiet" && return;;
167 esac
168 shift
169 printf "%s" "$*"
170 tput sgr0
171 echo
174 else
175 say_color() {
176 test -z "$1" && test -n "$quiet" && return
177 shift
178 echo "$*"
182 error () {
183 say_color error "error: $*"
184 GIT_EXIT_OK=t
185 exit 1
188 say () {
189 say_color info "$*"
192 test "${test_description}" != "" ||
193 error "Test script did not set test_description."
195 if test "$help" = "t"
196 then
197 echo "$test_description"
198 exit 0
201 exec 5>&1
202 if test "$verbose" = "t"
203 then
204 exec 4>&2 3>&1
205 else
206 exec 4>/dev/null 3>/dev/null
209 test_failure=0
210 test_count=0
211 test_fixed=0
212 test_broken=0
213 test_success=0
215 test_external_has_tap=0
217 die () {
218 code=$?
219 if test -n "$GIT_EXIT_OK"
220 then
221 exit $code
222 else
223 echo >&5 "FATAL: Unexpected exit with code $code"
224 exit 1
228 GIT_EXIT_OK=
229 trap 'die' EXIT
231 # The semantics of the editor variables are that of invoking
232 # sh -c "$EDITOR \"$@\"" files ...
234 # If our trash directory contains shell metacharacters, they will be
235 # interpreted if we just set $EDITOR directly, so do a little dance with
236 # environment variables to work around this.
238 # In particular, quoting isn't enough, as the path may contain the same quote
239 # that we're using.
240 test_set_editor () {
241 FAKE_EDITOR="$1"
242 export FAKE_EDITOR
243 EDITOR='"$FAKE_EDITOR"'
244 export EDITOR
247 test_decode_color () {
248 awk '
249 function name(n) {
250 if (n == 0) return "RESET";
251 if (n == 1) return "BOLD";
252 if (n == 30) return "BLACK";
253 if (n == 31) return "RED";
254 if (n == 32) return "GREEN";
255 if (n == 33) return "YELLOW";
256 if (n == 34) return "BLUE";
257 if (n == 35) return "MAGENTA";
258 if (n == 36) return "CYAN";
259 if (n == 37) return "WHITE";
260 if (n == 40) return "BLACK";
261 if (n == 41) return "BRED";
262 if (n == 42) return "BGREEN";
263 if (n == 43) return "BYELLOW";
264 if (n == 44) return "BBLUE";
265 if (n == 45) return "BMAGENTA";
266 if (n == 46) return "BCYAN";
267 if (n == 47) return "BWHITE";
270 while (match($0, /\033\[[0-9;]*m/) != 0) {
271 printf "%s<", substr($0, 1, RSTART-1);
272 codes = substr($0, RSTART+2, RLENGTH-3);
273 if (length(codes) == 0)
274 printf "%s", name(0)
275 else {
276 n = split(codes, ary, ";");
277 sep = "";
278 for (i = 1; i <= n; i++) {
279 printf "%s%s", sep, name(ary[i]);
280 sep = ";"
283 printf ">";
284 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
286 print
291 nul_to_q () {
292 perl -pe 'y/\000/Q/'
295 q_to_nul () {
296 perl -pe 'y/Q/\000/'
299 q_to_cr () {
300 tr Q '\015'
303 q_to_tab () {
304 tr Q '\011'
307 append_cr () {
308 sed -e 's/$/Q/' | tr Q '\015'
311 remove_cr () {
312 tr '\015' Q | sed -e 's/Q$//'
315 # In some bourne shell implementations, the "unset" builtin returns
316 # nonzero status when a variable to be unset was not set in the first
317 # place.
319 # Use sane_unset when that should not be considered an error.
321 sane_unset () {
322 unset "$@"
323 return 0
326 test_tick () {
327 if test -z "${test_tick+set}"
328 then
329 test_tick=1112911993
330 else
331 test_tick=$(($test_tick + 60))
333 GIT_COMMITTER_DATE="$test_tick -0700"
334 GIT_AUTHOR_DATE="$test_tick -0700"
335 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
338 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
340 # This will commit a file with the given contents and the given commit
341 # message. It will also add a tag with <message> as name.
343 # Both <file> and <contents> default to <message>.
345 test_commit () {
346 file=${2:-"$1.t"}
347 echo "${3-$1}" > "$file" &&
348 git add "$file" &&
349 test_tick &&
350 git commit -m "$1" &&
351 git tag "$1"
354 # Call test_merge with the arguments "<message> <commit>", where <commit>
355 # can be a tag pointing to the commit-to-merge.
357 test_merge () {
358 test_tick &&
359 git merge -m "$1" "$2" &&
360 git tag "$1"
363 # This function helps systems where core.filemode=false is set.
364 # Use it instead of plain 'chmod +x' to set or unset the executable bit
365 # of a file in the working directory and add it to the index.
367 test_chmod () {
368 chmod "$@" &&
369 git update-index --add "--chmod=$@"
372 # Use test_set_prereq to tell that a particular prerequisite is available.
373 # The prerequisite can later be checked for in two ways:
375 # - Explicitly using test_have_prereq.
377 # - Implicitly by specifying the prerequisite tag in the calls to
378 # test_expect_{success,failure,code}.
380 # The single parameter is the prerequisite tag (a simple word, in all
381 # capital letters by convention).
383 test_set_prereq () {
384 satisfied="$satisfied$1 "
386 satisfied=" "
388 test_have_prereq () {
389 # prerequisites can be concatenated with ','
390 save_IFS=$IFS
391 IFS=,
392 set -- $*
393 IFS=$save_IFS
395 total_prereq=0
396 ok_prereq=0
397 missing_prereq=
399 for prerequisite
401 total_prereq=$(($total_prereq + 1))
402 case $satisfied in
403 *" $prerequisite "*)
404 ok_prereq=$(($ok_prereq + 1))
407 # Keep a list of missing prerequisites
408 if test -z "$missing_prereq"
409 then
410 missing_prereq=$prerequisite
411 else
412 missing_prereq="$prerequisite,$missing_prereq"
414 esac
415 done
417 test $total_prereq = $ok_prereq
420 test_declared_prereq () {
421 case ",$test_prereq," in
422 *,$1,*)
423 return 0
425 esac
426 return 1
429 # You are not expected to call test_ok_ and test_failure_ directly, use
430 # the text_expect_* functions instead.
432 test_ok_ () {
433 test_success=$(($test_success + 1))
434 say_color "" "ok $test_count - $@"
437 test_failure_ () {
438 test_failure=$(($test_failure + 1))
439 say_color error "not ok - $test_count $1"
440 shift
441 echo "$@" | sed -e 's/^/# /'
442 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
445 test_known_broken_ok_ () {
446 test_fixed=$(($test_fixed+1))
447 say_color "" "ok $test_count - $@ # TODO known breakage"
450 test_known_broken_failure_ () {
451 test_broken=$(($test_broken+1))
452 say_color skip "not ok $test_count - $@ # TODO known breakage"
455 test_debug () {
456 test "$debug" = "" || eval "$1"
459 test_run_ () {
460 test_cleanup=:
461 eval >&3 2>&4 "$1"
462 eval_ret=$?
463 eval >&3 2>&4 "$test_cleanup"
464 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
465 echo ""
467 return 0
470 test_skip () {
471 test_count=$(($test_count+1))
472 to_skip=
473 for skp in $GIT_SKIP_TESTS
475 case $this_test.$test_count in
476 $skp)
477 to_skip=t
478 break
479 esac
480 done
481 if test -z "$to_skip" && test -n "$test_prereq" &&
482 ! test_have_prereq "$test_prereq"
483 then
484 to_skip=t
486 case "$to_skip" in
488 of_prereq=
489 if test "$missing_prereq" != "$test_prereq"
490 then
491 of_prereq=" of $test_prereq"
494 say_color skip >&3 "skipping test: $@"
495 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
496 : true
499 false
501 esac
504 test_expect_failure () {
505 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
506 test "$#" = 2 ||
507 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
508 export test_prereq
509 if ! test_skip "$@"
510 then
511 say >&3 "checking known breakage: $2"
512 test_run_ "$2"
513 if [ "$?" = 0 -a "$eval_ret" = 0 ]
514 then
515 test_known_broken_ok_ "$1"
516 else
517 test_known_broken_failure_ "$1"
520 echo >&3 ""
523 test_expect_success () {
524 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
525 test "$#" = 2 ||
526 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
527 export test_prereq
528 if ! test_skip "$@"
529 then
530 say >&3 "expecting success: $2"
531 test_run_ "$2"
532 if [ "$?" = 0 -a "$eval_ret" = 0 ]
533 then
534 test_ok_ "$1"
535 else
536 test_failure_ "$@"
539 echo >&3 ""
542 # test_external runs external test scripts that provide continuous
543 # test output about their progress, and succeeds/fails on
544 # zero/non-zero exit code. It outputs the test output on stdout even
545 # in non-verbose mode, and announces the external script with "# run
546 # <n>: ..." before running it. When providing relative paths, keep in
547 # mind that all scripts run in "trash directory".
548 # Usage: test_external description command arguments...
549 # Example: test_external 'Perl API' perl ../path/to/test.pl
550 test_external () {
551 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
552 test "$#" = 3 ||
553 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
554 descr="$1"
555 shift
556 export test_prereq
557 if ! test_skip "$descr" "$@"
558 then
559 # Announce the script to reduce confusion about the
560 # test output that follows.
561 say_color "" "# run $test_count: $descr ($*)"
562 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
563 # to be able to use them in script
564 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
565 # Run command; redirect its stderr to &4 as in
566 # test_run_, but keep its stdout on our stdout even in
567 # non-verbose mode.
568 "$@" 2>&4
569 if [ "$?" = 0 ]
570 then
571 if test $test_external_has_tap -eq 0; then
572 test_ok_ "$descr"
573 else
574 say_color "" "# test_external test $descr was ok"
575 test_success=$(($test_success + 1))
577 else
578 if test $test_external_has_tap -eq 0; then
579 test_failure_ "$descr" "$@"
580 else
581 say_color error "# test_external test $descr failed: $@"
582 test_failure=$(($test_failure + 1))
588 # Like test_external, but in addition tests that the command generated
589 # no output on stderr.
590 test_external_without_stderr () {
591 # The temporary file has no (and must have no) security
592 # implications.
593 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
594 stderr="$tmp/git-external-stderr.$$.tmp"
595 test_external "$@" 4> "$stderr"
596 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
597 descr="no stderr: $1"
598 shift
599 say >&3 "# expecting no stderr from previous command"
600 if [ ! -s "$stderr" ]; then
601 rm "$stderr"
603 if test $test_external_has_tap -eq 0; then
604 test_ok_ "$descr"
605 else
606 say_color "" "# test_external_without_stderr test $descr was ok"
607 test_success=$(($test_success + 1))
609 else
610 if [ "$verbose" = t ]; then
611 output=`echo; echo "# Stderr is:"; cat "$stderr"`
612 else
613 output=
615 # rm first in case test_failure exits.
616 rm "$stderr"
617 if test $test_external_has_tap -eq 0; then
618 test_failure_ "$descr" "$@" "$output"
619 else
620 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
621 test_failure=$(($test_failure + 1))
626 # debugging-friendly alternatives to "test [-f|-d|-e]"
627 # The commands test the existence or non-existence of $1. $2 can be
628 # given to provide a more precise diagnosis.
629 test_path_is_file () {
630 if ! [ -f "$1" ]
631 then
632 echo "File $1 doesn't exist. $*"
633 false
637 test_path_is_dir () {
638 if ! [ -d "$1" ]
639 then
640 echo "Directory $1 doesn't exist. $*"
641 false
645 test_path_is_missing () {
646 if [ -e "$1" ]
647 then
648 echo "Path exists:"
649 ls -ld "$1"
650 if [ $# -ge 1 ]; then
651 echo "$*"
653 false
657 # test_line_count checks that a file has the number of lines it
658 # ought to. For example:
660 # test_expect_success 'produce exactly one line of output' '
661 # do something >output &&
662 # test_line_count = 1 output
665 # is like "test $(wc -l <output) = 1" except that it passes the
666 # output through when the number of lines is wrong.
668 test_line_count () {
669 if test $# != 3
670 then
671 error "bug in the test script: not 3 parameters to test_line_count"
672 elif ! test $(wc -l <"$3") "$1" "$2"
673 then
674 echo "test_line_count: line count for $3 !$1 $2"
675 cat "$3"
676 return 1
680 # This is not among top-level (test_expect_success | test_expect_failure)
681 # but is a prefix that can be used in the test script, like:
683 # test_expect_success 'complain and die' '
684 # do something &&
685 # do something else &&
686 # test_must_fail git checkout ../outerspace
689 # Writing this as "! git checkout ../outerspace" is wrong, because
690 # the failure could be due to a segv. We want a controlled failure.
692 test_must_fail () {
693 "$@"
694 exit_code=$?
695 if test $exit_code = 0; then
696 echo >&2 "test_must_fail: command succeeded: $*"
697 return 1
698 elif test $exit_code -gt 129 -a $exit_code -le 192; then
699 echo >&2 "test_must_fail: died by signal: $*"
700 return 1
701 elif test $exit_code = 127; then
702 echo >&2 "test_must_fail: command not found: $*"
703 return 1
705 return 0
708 # Similar to test_must_fail, but tolerates success, too. This is
709 # meant to be used in contexts like:
711 # test_expect_success 'some command works without configuration' '
712 # test_might_fail git config --unset all.configuration &&
713 # do something
716 # Writing "git config --unset all.configuration || :" would be wrong,
717 # because we want to notice if it fails due to segv.
719 test_might_fail () {
720 "$@"
721 exit_code=$?
722 if test $exit_code -gt 129 -a $exit_code -le 192; then
723 echo >&2 "test_might_fail: died by signal: $*"
724 return 1
725 elif test $exit_code = 127; then
726 echo >&2 "test_might_fail: command not found: $*"
727 return 1
729 return 0
732 # Similar to test_must_fail and test_might_fail, but check that a
733 # given command exited with a given exit code. Meant to be used as:
735 # test_expect_success 'Merge with d/f conflicts' '
736 # test_expect_code 1 git merge "merge msg" B master
739 test_expect_code () {
740 want_code=$1
741 shift
742 "$@"
743 exit_code=$?
744 if test $exit_code = $want_code
745 then
746 echo >&2 "test_expect_code: command exited with $exit_code: $*"
747 return 0
748 else
749 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
750 return 1
754 # test_cmp is a helper function to compare actual and expected output.
755 # You can use it like:
757 # test_expect_success 'foo works' '
758 # echo expected >expected &&
759 # foo >actual &&
760 # test_cmp expected actual
763 # This could be written as either "cmp" or "diff -u", but:
764 # - cmp's output is not nearly as easy to read as diff -u
765 # - not all diff versions understand "-u"
767 test_cmp() {
768 $GIT_TEST_CMP "$@"
771 # This function can be used to schedule some commands to be run
772 # unconditionally at the end of the test to restore sanity:
774 # test_expect_success 'test core.capslock' '
775 # git config core.capslock true &&
776 # test_when_finished "git config --unset core.capslock" &&
777 # hello world
780 # That would be roughly equivalent to
782 # test_expect_success 'test core.capslock' '
783 # git config core.capslock true &&
784 # hello world
785 # git config --unset core.capslock
788 # except that the greeting and config --unset must both succeed for
789 # the test to pass.
791 test_when_finished () {
792 test_cleanup="{ $*
793 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
796 # Most tests can use the created repository, but some may need to create more.
797 # Usage: test_create_repo <directory>
798 test_create_repo () {
799 test "$#" = 1 ||
800 error "bug in the test script: not 1 parameter to test-create-repo"
801 repo="$1"
802 mkdir -p "$repo"
804 cd "$repo" || error "Cannot setup test environment"
805 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
806 error "cannot run git init -- have you built things yet?"
807 mv .git/hooks .git/hooks-disabled
808 ) || exit
811 test_done () {
812 GIT_EXIT_OK=t
814 if test -z "$HARNESS_ACTIVE"; then
815 test_results_dir="$TEST_DIRECTORY/test-results"
816 mkdir -p "$test_results_dir"
817 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
819 echo "total $test_count" >> $test_results_path
820 echo "success $test_success" >> $test_results_path
821 echo "fixed $test_fixed" >> $test_results_path
822 echo "broken $test_broken" >> $test_results_path
823 echo "failed $test_failure" >> $test_results_path
824 echo "" >> $test_results_path
827 if test "$test_fixed" != 0
828 then
829 say_color pass "# fixed $test_fixed known breakage(s)"
831 if test "$test_broken" != 0
832 then
833 say_color error "# still have $test_broken known breakage(s)"
834 msg="remaining $(($test_count-$test_broken)) test(s)"
835 else
836 msg="$test_count test(s)"
838 case "$test_failure" in
840 # Maybe print SKIP message
841 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
843 if test $test_external_has_tap -eq 0; then
844 say_color pass "# passed all $msg"
845 say "1..$test_count$skip_all"
848 test -d "$remove_trash" &&
849 cd "$(dirname "$remove_trash")" &&
850 rm -rf "$(basename "$remove_trash")"
852 exit 0 ;;
855 if test $test_external_has_tap -eq 0; then
856 say_color error "# failed $test_failure among $msg"
857 say "1..$test_count"
860 exit 1 ;;
862 esac
865 # Test the binaries we have just built. The tests are kept in
866 # t/ subdirectory and are run in 'trash directory' subdirectory.
867 if test -z "$TEST_DIRECTORY"
868 then
869 # We allow tests to override this, in case they want to run tests
870 # outside of t/, e.g. for running tests on the test library
871 # itself.
872 TEST_DIRECTORY=$(pwd)
874 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
876 if test -n "$valgrind"
877 then
878 make_symlink () {
879 test -h "$2" &&
880 test "$1" = "$(readlink "$2")" || {
881 # be super paranoid
882 if mkdir "$2".lock
883 then
884 rm -f "$2" &&
885 ln -s "$1" "$2" &&
886 rm -r "$2".lock
887 else
888 while test -d "$2".lock
890 say "Waiting for lock on $2."
891 sleep 1
892 done
897 make_valgrind_symlink () {
898 # handle only executables
899 test -x "$1" || return
901 base=$(basename "$1")
902 symlink_target=$GIT_BUILD_DIR/$base
903 # do not override scripts
904 if test -x "$symlink_target" &&
905 test ! -d "$symlink_target" &&
906 test "#!" != "$(head -c 2 < "$symlink_target")"
907 then
908 symlink_target=../valgrind.sh
910 case "$base" in
911 *.sh|*.perl)
912 symlink_target=../unprocessed-script
913 esac
914 # create the link, or replace it if it is out of date
915 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
918 # override all git executables in TEST_DIRECTORY/..
919 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
920 mkdir -p "$GIT_VALGRIND"/bin
921 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
923 make_valgrind_symlink $file
924 done
925 OLDIFS=$IFS
926 IFS=:
927 for path in $PATH
929 ls "$path"/git-* 2> /dev/null |
930 while read file
932 make_valgrind_symlink "$file"
933 done
934 done
935 IFS=$OLDIFS
936 PATH=$GIT_VALGRIND/bin:$PATH
937 GIT_EXEC_PATH=$GIT_VALGRIND/bin
938 export GIT_VALGRIND
939 elif test -n "$GIT_TEST_INSTALLED" ; then
940 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
941 error "Cannot run git from $GIT_TEST_INSTALLED."
942 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
943 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
944 else # normal case, use ../bin-wrappers only unless $with_dashes:
945 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
946 if ! test -x "$git_bin_dir/git" ; then
947 if test -z "$with_dashes" ; then
948 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
950 with_dashes=t
952 PATH="$git_bin_dir:$PATH"
953 GIT_EXEC_PATH=$GIT_BUILD_DIR
954 if test -n "$with_dashes" ; then
955 PATH="$GIT_BUILD_DIR:$PATH"
958 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
959 unset GIT_CONFIG
960 GIT_CONFIG_NOSYSTEM=1
961 GIT_CONFIG_NOGLOBAL=1
962 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
964 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
966 if test -z "$GIT_TEST_CMP"
967 then
968 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
969 then
970 GIT_TEST_CMP="$DIFF -c"
971 else
972 GIT_TEST_CMP="$DIFF -u"
976 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
977 export GITPERLLIB
978 test -d "$GIT_BUILD_DIR"/templates/blt || {
979 error "You haven't built things yet, have you?"
982 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
983 then
984 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
985 export GITPYTHONLIB
986 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
987 error "You haven't built git_remote_helpers yet, have you?"
991 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
992 echo >&2 'You need to build test-chmtime:'
993 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
994 exit 1
997 # Test repository
998 test="trash directory.$(basename "$0" .sh)"
999 test -n "$root" && test="$root/$test"
1000 case "$test" in
1001 /*) TRASH_DIRECTORY="$test" ;;
1002 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1003 esac
1004 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1005 rm -fr "$test" || {
1006 GIT_EXIT_OK=t
1007 echo >&5 "FATAL: Cannot prepare test area"
1008 exit 1
1011 test_create_repo "$test"
1012 # Use -P to resolve symlinks in our working directory so that the cwd
1013 # in subprocesses like git equals our $PWD (for pathname comparisons).
1014 cd -P "$test" || exit 1
1016 HOME=$(pwd)
1017 export HOME
1019 this_test=${0##*/}
1020 this_test=${this_test%%-*}
1021 for skp in $GIT_SKIP_TESTS
1023 case "$this_test" in
1024 $skp)
1025 say_color skip >&3 "skipping test $this_test altogether"
1026 skip_all="skip all tests in $this_test"
1027 test_done
1028 esac
1029 done
1031 # Provide an implementation of the 'yes' utility
1032 yes () {
1033 if test $# = 0
1034 then
1036 else
1037 y="$*"
1040 while echo "$y"
1043 done
1046 # Fix some commands on Windows
1047 case $(uname -s) in
1048 *MINGW*)
1049 # Windows has its own (incompatible) sort and find
1050 sort () {
1051 /usr/bin/sort "$@"
1053 find () {
1054 /usr/bin/find "$@"
1056 sum () {
1057 md5sum "$@"
1059 # git sees Windows-style pwd
1060 pwd () {
1061 builtin pwd -W
1063 # no POSIX permissions
1064 # backslashes in pathspec are converted to '/'
1065 # exec does not inherit the PID
1066 test_set_prereq MINGW
1067 test_set_prereq SED_STRIPS_CR
1069 *CYGWIN*)
1070 test_set_prereq POSIXPERM
1071 test_set_prereq EXECKEEPSPID
1072 test_set_prereq NOT_MINGW
1073 test_set_prereq SED_STRIPS_CR
1076 test_set_prereq POSIXPERM
1077 test_set_prereq BSLASHPSPEC
1078 test_set_prereq EXECKEEPSPID
1079 test_set_prereq NOT_MINGW
1081 esac
1083 test -z "$NO_PERL" && test_set_prereq PERL
1084 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1086 # test whether the filesystem supports symbolic links
1087 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1088 rm -f y
1090 # When the tests are run as root, permission tests will report that
1091 # things are writable when they shouldn't be.
1092 test -w / || test_set_prereq SANITY